//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************
PROGMEM char telnet_OK[] = {0x00,'%','E','N','D'};

void telnet (char* buffer,int *bufferlen)
{
	unsigned int result16;
	if ((buffer[TCP_hdrflags+1]&PSH_Flag) > 0 )
		{
		//Errechnet startpunkt der Daten im Tcp buffer
		//IP Headerlnge + TCP Headerlnge + Ethernetframe
		result16 = ((buffer[ip_vers_len] & 0x0F) << 2) + ((buffer[TCP_hdrflags] & 0xF0) >>2) + 14;		
		//Ausgabe des empfangenen Zeichens
		loop_until_bit_is_set(USR, UDRE);
		UDR = (buffer[result16]);
		if (buffer[result16]==0x0d)
			{
			loop_until_bit_is_set(USR, UDRE);
			UDR = 0x0a;
			};
		
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);				

		tcp_add_data (telnet_OK,buffer,bufferlen);
				
		buffer[TCP_hdrflags+1] = ACK_Flag;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);
		}
}
